//------------------------------------------------------------------------------------------------

//
// File: linesegment.cpp
// Author: Roman Lysecky
// Date Created: 28 November 2011
// 
// Description: Implementation of a LineSegment class.
// 
// Copyright: Roman Lysecky, Electrical and Computer Engineering, University of Arizona, 2011.
// 
// 

//------------------------------------------------------------------------------------------------

#include <iostream>
#include "linesegment.h"

//------------------------------------------------------------------------------------------------

using namespace std;

//------------------------------------------------------------------------------------------------
//
// Simple constructor for LineSegment Class
//
LineSegment::LineSegment() {
    x1 = 0;
    y1 = 0;
    x2 = 0;
    y2 = 0;
    next = 0;
    
    cout << "(" << this << ") ";
    cout << "Line Segment (" << x1 << "," << y1 << ")->(" << x2 << "," << y2 
         << ") constructed (using simple constructor) " << endl;
}

//------------------------------------------------------------------------------------------------
//
// Constructor with optional inputs for all LineSegment elements (x1, y1, x2, y2)
//
LineSegment::LineSegment(float x1_, float y1_, float x2_, float y2_)
{    
    x1 = x1_;
    y1 = y1_;
    x2 = x2_;
    y2 = y2_;
    next = 0;

    cout << "(" << this << ") ";
    cout << "Line Segment (" << x1 << "," << y1 << ")->(" << x2 << "," << y2 
         << ") constructed (using constructor with arguments) " << endl;
}

//------------------------------------------------------------------------------------------------

LineSegment::LineSegment(const LineSegment &fromLineSegment)
{
    x1 = fromLineSegment.x1;
    y1 = fromLineSegment.y1;
    x2 = fromLineSegment.x2;
    y2 = fromLineSegment.y2;  
    next = fromLineSegment.next;

    cout << "(" << this << ") ";
    cout << "Line Segment (" << x1 << "," << y1 << ")->(" << x2 << "," << y2 
         << ") constructed (using copy constructor) " << endl;
}

//------------------------------------------------------------------------------------------------

LineSegment::~LineSegment() {
    cout << "(" << this << ") ";
    cout << "Line Segment (" << x1 << "," << y1 << ")->(" << x2 << "," << y2 
         << ") destructed " << (hex) << endl;
}

//------------------------------------------------------------------------------------------------

LineSegment & 
LineSegment::operator=(const LineSegment &rhs)
{
    x1 = rhs.x1;
    y1 = rhs.y1;
    x2 = rhs.x2;
    y2 = rhs.y2;  
    next = rhs.next;
   
    cout << "(" << this << ") ";
    cout << "Line Segment (" << x1 << "," << y1 << ")->(" << x2 << "," << y2 
    << ") copied (using assignment operator)" << endl;
    
    return *this;
}

//------------------------------------------------------------------------------------------------

ostream & 
operator<< (ostream &os, LineSegment &lineSegment)
{
    os << "(" << lineSegment.x1 << "," << lineSegment.y1 << ")->(" 
       << lineSegment.x2 << "," << lineSegment.y2 << ")";
    
    return os;
}

//------------------------------------------------------------------------------------------------

