//------------------------------------------------------------------------------------------------


//
// File: main.cpp
// Author: Roman Lysecky
// Date Created: 28 November 2011
// 
// Copyright: Roman Lysecky, Electrical and Computer Engineering, University of Arizona, 2011.
// 
//

//------------------------------------------------------------------------------------------------

#include "linesegment.h"
#include "polygon.h"
#include <iostream>

//------------------------------------------------------------------------------------------------

void return_by_ref_with_pointer(int *x_ptr)
{
    *x_ptr = 5;
}

//------------------------------------------------------------------------------------------------

void return_by_ref_with_ref(int &x_ref)
{
    x_ref = 6;
}

//------------------------------------------------------------------------------------------------

LineSegment 
move_segment(LineSegment a, int x_dist, int y_dist)
{
    a.x1 += x_dist;
    a.y1 += y_dist;
    a.x2 += x_dist;
    a.y2 += y_dist;
    
    return a;
}

//------------------------------------------------------------------------------------------------

int 
main() 
{
    int a=0;
    int b=0;
    
    // Time for some pass by reference fun!
    return_by_ref_with_pointer(&a);
    return_by_ref_with_ref(b);
    
    cout << "a = " << a << endl;
    cout << "b = " << b << endl;
    
    // How about some fun with constructors and destructors?

    // LineSegment segment_a;
    LineSegment segment_b(1, 2);
    //LineSegment segment_c = segment_b;
    LineSegment moved_segment;
    
    moved_segment = move_segment(segment_b, 100, 43);

    cout << flush;
    
    // And now for something completely different.

    Polygon polygon1;
    
    polygon1.insert_segment_next(0, 0, 0, 5);
    polygon1.insert_segment_next(5, 5, 0, 5);
    polygon1.insert_segment_next(5, 5, 5, 0);
    polygon1.insert_segment_next(5, 0, 0, 0);
        
    polygon1.display();
    
    if( polygon1.is_valid() ) {
        std::cout << " is a valid polygon." << std::endl;
    }
    else {
        std::cout << " is not a valid polygon." << std::endl;
    }
       
    std::cout << std::flush;
    
    return 0;
}

//------------------------------------------------------------------------------------------------

